<?php
if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

require_once "./plugins/category_theme/initialize.inc.php";

$thisplugin->add_filter('theme_name','category_theme_name');

function category_theme_name ($name) {
	global $superCage;
	$tn = $name;
	if ($superCage->get->keyExists('cat')) $tn = category_theme_getName($superCage->get->getInt('cat'));
	elseif ($superCage->get->keyExists('album')) $tn = category_theme_getName(0, $superCage->get->getInt('album'));
	return $tn ?: $name;
}

function category_theme_getName ($cat, $alb=0)
{
	global $superCage, $CONFIG;
	if (!$cat) {
		if (!$alb) {
			$pid = $superCage->get->getInt('pid');
			$alb = cpg_db_result(cpg_db_query("SELECT `aid` FROM {$CONFIG['TABLE_PICTURES']} WHERE `pid`={$pid}"));
		}
		$albCat = cpg_db_result(cpg_db_query("SELECT `category` FROM {$CONFIG['TABLE_ALBUMS']} WHERE `aid`={$alb}"));
		$cat = $albCat;
	}
	if ($cat > FIRST_USER_CAT) $cat = floor($cat / FIRST_USER_CAT);
	$row = cpg_db_fetch_assoc(cpg_db_query("SELECT `parent`,`theme_name` FROM {$CONFIG['TABLE_CATEGORIES']} WHERE `cid`={$cat}"));
	if (true) while ((empty($row['theme_name'])) && ($row['parent'] != 0)) {
		$row = cpg_db_fetch_assoc(cpg_db_query("SELECT `parent`,`theme_name` FROM {$CONFIG['TABLE_CATEGORIES']} WHERE `cid`={$row['parent']}"));
	}
	$tnam = $row['theme_name'];
	return $tnam;
}

/***** INSTALL/UNINSTALL *****/

$thisplugin->add_action('plugin_install', 'category_theme_install');
function category_theme_install () {
	global $CONFIG;
	cpg_db_query("ALTER TABLE {$CONFIG['TABLE_CATEGORIES']} ADD `theme_name` VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci");
	return true;
}

$thisplugin->add_action('plugin_uninstall', 'category_theme_uninstall');
function category_theme_uninstall () {
	global $CONFIG;
	cpg_db_query("ALTER TABLE {$CONFIG['TABLE_CATEGORIES']} DROP `theme_name`");
	return true;
}
